// =========================== ATTINY2313V CPU ׽Ʈ α׷ ================
//  CPU : ATTINY2313V-12M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : Avrstudio
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
//#define	__STDIO_FDEVOPEN_COMPAT_12

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
//#include <ctype.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);				// CPU PORT I/O ׽Ʈ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpuʱȭ
	main_menu_disp();						//  ޴ ǥ
	while(1){								// Place your code here
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else putchar_0(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}


// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	com_puts("\r\n");
	com_puts("- 1  : CPU I/O TEST -\r\n");
}

// =============================== CPUIO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	com_puts("======== CPU I/O TEST =======\r\n");
	com_puts("- 0  : TOP menu              \r\n");

// CPU PORT   
// PORTB[0..7] : OUT 
	PORTB=0xff;								// Ʈ  reg
	DDRB=0xff;								// Ʈ  reg(0Է,1)
// PORTD[0..7] : OUT 
	PORTD=0xfc;								// Ʈ  reg
	DDRD=0xfc;								// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
	TCCR0A=0x00;
	TCCR0B = 0x05;							// system clock,16,000,000 / 1024 = 11.719Khz
	TCNT0 = 138;							// 255-156 = 99	
	OCR0A=0x00;
	OCR0B=0x00;
	TIMSK |= 0x02;							// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;							// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar_0(com1_rx_data);	// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt <= 7) PORTB = ~(1 << out_cnt);// PORTB (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt <= 11){	// PORTD 
				if(out_cnt == 8) PORTB = 0xff;// PORTB CLEAR
				PORTD = ~(4 << (out_cnt-8));// PORTD (ش Ʈ 0)
			}
			out_cnt++;						//  ġ ī 
			if(out_cnt >= 15) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){				//  ü ʱȭ
				PORTB = 0xff;
				PORTD = 0xff;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A=0x00;
	TCCR0B = 0x00;							// system clock,16,000,000 / 1024 = 11.719Khz
	TCNT0 = 0;								// 255-156 = 99	
	OCR0A=0x00;
	OCR0B=0x00;
	TIMSK &= 0xfd;							// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTB
	PORTB=0x00;								// Ʈ  reg
	DDRB=0x00;								// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;								// Ʈ  reg
	DDRD=0x00;								// Ʈ  reg(0Է,1)
	
	main_menu_disp();						//  ޴ ǥ
}
