// ========================== ATTINY2313V CPU ׽Ʈ α׷ =================
//  CPU : ATTINY2313V-12M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
//            I/O ͷƮ ׽Ʈ
// ----------------------------------------------------------------------------
// ⺻ 
#include <tiny2313.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void exint_test(void);						// EXINT0,1 TEST

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') exint_test();  	// EXINT0,1 TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : EXINT0,1 TEST                            \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("============== EXINT0,1 TEST ==========\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- interrupt : INT0 Falling Edge        \r\n");
	printf("-             INT1 Falling Edge        \r\n");
	printf("---------------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
	GIMSK = 0xC0;
	MCUCR = 0x0A;
	EIFR  = 0xC0;

        PORTD |= 0x0c;                                          // INT0,1 PULL UP
	
	exint0_flg = exint1_flg = 0;				// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
	}

// External Interrupt(s) 
	GIMSK &= 0x3f;
	MCUCR = 0x00;
	EIFR  = 0x00;

        PORTD &= 0xf3;                                          // INT0,1 Ʈ ʱġ
	
	main_menu_disp();					//  ޴ ǥ
}
